package de.uni_potsdam.hpi.isg.efes.csg.datafit.simple;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

import de.uni_potsdam.hpi.isg.efes.csg.datafit.DataFitReport;

public class SimpleReportSection implements DataFitReport.Section {

	private List<DataSet> sourceDataSets = new ArrayList<>();
	private DataSet targetDataSet;

	@Override
	public void print(PrintStream stream) {
		stream.println("Simple complexity report");
		stream.println("========================");
		stream.format(" %d sources:\n", this.sourceDataSets.size());
		for (DataSet sourceDataSet : this.sourceDataSets) {
			stream.format(" * %s\n", sourceDataSet);
		}
		stream.println(" Target:");
		stream.format(" * %s\n", this.targetDataSet);
	}

	public void addSourceDataSet(DataSet source) {
		this.sourceDataSets.add(source);
	}

	public DataSet getTargetDataSet() {
		return targetDataSet;
	}

	public void setTargetDataSet(DataSet targetDataSet) {
		this.targetDataSet = targetDataSet;
	}

	public List<DataSet> getSourceDataSets() {
		return sourceDataSets;
	}

	public static class DataSet {

		private int numAttributes, numMetaDataAttributes, numCorrespondences, numTables;
		private String name;
		
		public DataSet(String name) {
			this.name = name;
		}

		public int getNumTables() {
			return numTables;
		}

		public void setNumTables(int numTables) {
			this.numTables = numTables;
		}

		public int getNumAttributes() {
			return numAttributes;
		}

		public void setNumAttributes(int numAttributes) {
			this.numAttributes = numAttributes;
		}

		public int getNumMetaDataAttributes() {
			return numMetaDataAttributes;
		}

		public void setNumMetaDataAttributes(int numMetaDataAttributes) {
			this.numMetaDataAttributes = numMetaDataAttributes;
		}

		public int getNumCorrespondences() {
			return numCorrespondences;
		}

		public void setNumCorrespondences(int numCorrespondences) {
			this.numCorrespondences = numCorrespondences;
		}
		
		public String getName() {
			return name;
		}
		
		@Override
		public String toString() {
			return "DataSet [numAttributes=" + numAttributes + ", numMetaDataAttributes=" + numMetaDataAttributes
					+ ", numCorrespondences=" + numCorrespondences + ", numTables=" + numTables + ", name=" + name
					+ "]";
		}

	}

	@Override
	public void printCsv(PrintStream printStream) {
		// TODO Auto-generated method stub
		
	}

}
