package de.uni_potsdam.hpi.isg.efes.csg.datafit.values.conclusion;

import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.ValueCharacteristicsInspector.Issue;
import de.uni_potsdam.hpi.isg.efes.csg.mapping.NodeCorrespondence;

public class DifferentRepresentationsIssue extends Issue {

	private int complexity;
	private int numDistinctIncovertibleValues;
	private int numInconvertibleValues;
	private NodeCorrespondence correspondence;
	private boolean isCritical;
	private String additionalInformation;

	public DifferentRepresentationsIssue(NodeCorrespondence correspondence, int numInconvertibleValues,
			int numDistinctIncovertibleValues, int complexity, boolean isCritical) {
		this.correspondence = correspondence;
		this.numInconvertibleValues = numInconvertibleValues;
		this.numDistinctIncovertibleValues = numDistinctIncovertibleValues;
		this.complexity = complexity;
		this.isCritical = isCritical;
	}
	
	public void setAdditionalInformation(String additionalInformation) {
		this.additionalInformation = additionalInformation;
	}

	public int getComplexity() {
		return complexity;
	}

	public int getNumDistinctInconvertibleValues() {
		return numDistinctIncovertibleValues;
	}

	public int getNumInconvertibleValues() {
		return numInconvertibleValues;
	}

	public NodeCorrespondence getCorrespondence() {
		return correspondence;
	}

	@Override
	public String toString() {
		return "DifferentRepresentationsIssue [complexity=" + complexity + ", numDistinctIncovertibleValues="
				+ numDistinctIncovertibleValues + ", numInconvertibleValues=" + numInconvertibleValues
				+ ", correspondence=" + correspondence + (this.additionalInformation != null ? (", " + this.additionalInformation) : "") + "]";
	}

	public boolean isCritical() {
		return this.isCritical;
	}


}
