package de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.repair;

import java.util.Collection;
import java.util.List;

import de.uni_potsdam.hpi.isg.efes.csg.constraints.Constraint;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskList;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel.Profile;
import de.uni_potsdam.hpi.isg.efes.csg.instance.SchemaGraphInstance;
import de.uni_potsdam.hpi.isg.efes.csg.relationships.Relationship;

public interface SchemaGraphOperation {

	void addPredecessor(SchemaGraphOperation sgo);

	List<SchemaGraphOperation> getDirectPredecessors();
	
	boolean hasPredecessor(SchemaGraphOperation sgo);
	
	Relationship getTargetRelationship();

	Collection<Relationship> getSideEffectRelationships();
	
	boolean isTargetConstraintViolated();
	
	void execute();
	
	void undoOn(Relationship relationship);
	
	void executeOn(Relationship relationship);
	
	TaskList.Task executeAndReturnTask();
	
	public static interface Descriptor<SGO extends SchemaGraphOperation> {

		boolean isOperationApplicableTo(Constraint violatedConstraint, SchemaGraphInstance sgInstance);

		boolean matchesProfile(Profile profile);

		SGO applyTo(Constraint constraint, RepairSchemaGraphInstance sgInstance);

	}


}
