package de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.simple;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

import de.uni_potsdam.hpi.isg.efes.csg.datafit.DataFitReport.Section;
import de.uni_potsdam.hpi.isg.efes.csg.datafit.simple.SimpleReportSection;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskList;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel.Estimate;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel.Profile;
import de.uni_potsdam.hpi.isg.efes.csg.scenario.IntegrationScenario;

public class SimpleEffortModel implements TaskListModel.Submodel {

	@SuppressWarnings("unused")
	private IntegrationScenario integrationScenario;
	
	private Collection<TaskType> taskTypes = new ArrayList<>();

	@Override
	public Collection<Class<? extends Section>> getSupportedReportSectionClasses() {
		return Collections.<Class<? extends Section>>singleton(SimpleReportSection.class);
	}

	@Override
	public void setIntegrationScenario(IntegrationScenario integrationScenario) {
		this.integrationScenario = integrationScenario;
	}

	@Override
	public void setProfile(Profile profile) {
		// This model does not care about profiles.
	}

	@Override
	public TaskList createTaskList(Section section, Estimate estimate) {
		TaskList taskList = new TaskList();
		for (TaskType taskType : this.taskTypes) {
			taskType.addTasks(taskList, (SimpleReportSection) section);
		}
		return taskList;
	}

	public void addTaskType(TaskType taskType) {
		this.taskTypes.add(taskType);
	}
	
}
