package de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.transform;

import java.util.Collection;

import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.ValueCharacteristicsInspector.Issue;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel.Profile;

public abstract class AbstractTransformationOperation implements TransformationOperation {

	@Override
	public boolean supportsProfile(Profile profile) {
		return getSupportedProfiles().contains(profile);
	}

	abstract protected Collection<TaskListModel.Profile> getSupportedProfiles();

	@Override
	public boolean canHandle(Issue issue) {
		return getSupportedIssueClasses().contains(issue.getClass());
	}

	abstract protected Collection<Class<? extends Issue>> getSupportedIssueClasses();
	

}
