package de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.transform;

import java.util.Arrays;
import java.util.Collection;

import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.ValueCharacteristicsInspector.Issue;
import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.conclusion.FewElementsIssue;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskList.Task;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel.Profile;

public class AddValues extends AbstractTransformationOperation {

	@Override
	public Task toTask(Issue issue) {
		FewElementsIssue fewElementsIssue = (FewElementsIssue) issue;
		Task task = new Task("Add values", TransformModel.CATEGORY, fewElementsIssue.getCorrespondence().toString());
		task.setParameter("values", fewElementsIssue.getNeededValues());
		return task;
	}

	@Override
	protected Collection<Profile> getSupportedProfiles() {
		return Arrays.asList(TaskListModel.Profile.HIGH_QUALITY);
	}

	@Override
	protected Collection<Class<? extends Issue>> getSupportedIssueClasses() {
		return Arrays.<Class<? extends Issue>> asList(FewElementsIssue.class);
	}

}
