package de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.transform;

import java.util.Arrays;
import java.util.Collection;

import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.ValueCharacteristicsInspector.Issue;
import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.conclusion.DifferentRepresentationsIssue;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskList.Task;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel.Profile;

public class ConvertValues extends AbstractTransformationOperation {

	@Override
	public Task toTask(Issue issue) {
		DifferentRepresentationsIssue differentRepresentationsIssue = (DifferentRepresentationsIssue) issue;
		Task task = new Task("Convert values", TransformModel.CATEGORY, differentRepresentationsIssue
				.getCorrespondence().toString());
		task.setParameter("complexity", differentRepresentationsIssue.getComplexity());
		task.setParameter("values", differentRepresentationsIssue.getNumInconvertibleValues());
		task.setParameter("distinctvalues", differentRepresentationsIssue.getNumDistinctInconvertibleValues());
		return task;
	}

	@Override
	protected Collection<Profile> getSupportedProfiles() {
		return Arrays.asList(TaskListModel.Profile.HIGH_QUALITY);
	}

	@Override
	protected Collection<Class<? extends Issue>> getSupportedIssueClasses() {
		return Arrays.<Class<? extends Issue>> asList(DifferentRepresentationsIssue.class);
	}

}
