package de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.transform;

import java.util.Arrays;
import java.util.Collection;

import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.ValueCharacteristicsInspector.Issue;
import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.conclusion.TooSpecificIssue;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskList.Task;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel.Profile;

public class GeneralizeValues extends AbstractTransformationOperation {

	@Override
	public Task toTask(Issue issue) {
		TooSpecificIssue tooSpecificIssue = (TooSpecificIssue) issue;
		Task task = new Task("Generalize values", TransformModel.CATEGORY, tooSpecificIssue.getCorrespondence()
				.toString());
		task.setParameter("values", tooSpecificIssue.getNumValues());
		task.setParameter("distinctvalues", tooSpecificIssue.getNumDistinctValues());
		return task;
	}

	@Override
	protected Collection<Profile> getSupportedProfiles() {
		return Arrays.asList(TaskListModel.Profile.HIGH_QUALITY);
	}

	@Override
	protected Collection<Class<? extends Issue>> getSupportedIssueClasses() {
		return Arrays.<Class<? extends Issue>> asList(TooSpecificIssue.class);
	}

}
