package de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.transform;

import java.util.Arrays;
import java.util.Collection;

import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.ValueCharacteristicsInspector.Issue;
import de.uni_potsdam.hpi.isg.efes.csg.datafit.values.conclusion.TooGeneralIssue;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskList.Task;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel.Profile;

public class RefineValues extends AbstractTransformationOperation {

	@Override
	public Task toTask(Issue issue) {
		TooGeneralIssue tooGeneralIssue = (TooGeneralIssue) issue;
		Task task = new Task("Refine values", TransformModel.CATEGORY, tooGeneralIssue.getCorrespondence()
				.toString());
		task.setParameter("values", tooGeneralIssue.getNumValues());
		task.setParameter("distinctvalues", tooGeneralIssue.getNumDistinctValues());
		task.setParameter("complexity", tooGeneralIssue.getComplexity());
		return task;
	}

	@Override
	protected Collection<Profile> getSupportedProfiles() {
		return Arrays.asList(TaskListModel.Profile.HIGH_QUALITY);
	}

	@Override
	protected Collection<Class<? extends Issue>> getSupportedIssueClasses() {
		return Arrays.<Class<? extends Issue>> asList(TooGeneralIssue.class);
	}

}
