package de.uni_potsdam.hpi.isg.efes.pipeline.configuration.model;

import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;

import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.TaskListModel.Submodel;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.simple.SimpleEffortModel;
import de.uni_potsdam.hpi.isg.efes.csg.effort.tasklist.simple.TaskType;

public class SimpleEffortModelConfiguration extends TaskListSubmodelConfiguration {

	private List<SimpleEffortModelTaskTypeConfiguration> taskTypes;

	@Override
	public Submodel createSubmodel() {
		SimpleEffortModel model = new SimpleEffortModel();
		for (SimpleEffortModelTaskTypeConfiguration taskTypeConf : this.taskTypes) {
			TaskType taskType = TaskType.createTaskType(taskTypeConf.getName(), taskTypeConf.getCategory(),
					taskTypeConf.getScope());
			model.addTaskType(taskType);
		}
		return model;
	}

	@XmlElementWrapper(name = "taskTypes")
	@XmlElement(name = "taskType")
	public List<SimpleEffortModelTaskTypeConfiguration> getTaskTypes() {
		return taskTypes;
	}

	public void setTaskTypes(List<SimpleEffortModelTaskTypeConfiguration> taskTypes) {
		this.taskTypes = taskTypes;
	}

}
