package de.uni_potsdam.hpi.ist.efes.pipeline;

import java.io.IOException;
import java.io.InputStream;
import java.sql.SQLException;

import org.junit.Test;
import org.xml.sax.SAXException;

import de.uni_potsdam.hpi.isg.efes.csg.effort.EffortEstimate;
import de.uni_potsdam.hpi.isg.efes.csg.scenario.IntegrationScenario;
import de.uni_potsdam.hpi.isg.efes.csg.scenario.adapter.SpicyConfigurationScenarioBuilder;
import de.uni_potsdam.hpi.isg.efes.pipeline.Pipeline;
import de.uni_potsdam.hpi.isg.efes.pipeline.configuration.Configurations;
import de.uni_potsdam.hpi.isg.efes.pipeline.configuration.model.Configuration;
import de.uni_potsdam.hpi.isg.efes.spicy.SpicyConfiguration;
import de.uni_potsdam.hpi.isg.efes.spicy.SpicyParser;

public class PipelineTest {
	
	@Test
	public void testPipeline() throws SAXException, IOException, SQLException {
		Configuration configuration = Configurations.createExampleConfiguration();
		Pipeline pipeline = configuration.createPipeline();
		
		SpicyParser spicyParser = new SpicyParser();
//		InputStream resourceAsStream = getClass().getResourceAsStream("/discogs2freedb.xml");
//		InputStream resourceAsStream = getClass().getResourceAsStream("/freedb2freedb.xml");
		InputStream resourceAsStream = getClass().getResourceAsStream("/musicbrainz2discogs.xml");
		SpicyConfiguration spicyConfiguration = spicyParser.parse(resourceAsStream);

		SpicyConfigurationScenarioBuilder builder = new SpicyConfigurationScenarioBuilder();
		builder.add(spicyConfiguration);
		IntegrationScenario integrationScenario = builder.build();
		
		pipeline.process(integrationScenario, "h");
		EffortEstimate estimate = pipeline.getEffortEstimate();
		
		estimate.print(System.out);
	}

}
