package de.uni_potsdam.hpi.isg.efes.csg.mapping;

import de.uni_potsdam.hpi.isg.efes.csg.nodes.Node;

public class NodeCorrespondence {

	private Node sourceNode, targetNode;

	public NodeCorrespondence(Node sourceNode, Node targetNode) {
		if (sourceNode == null || targetNode == null)
			throw new IllegalArgumentException("Corresponding nodes must not be null: "
					+ sourceNode + ", " + targetNode);
		this.sourceNode = sourceNode;
		this.targetNode = targetNode;
	}

	public Node getSourceNode() {
		return sourceNode;
	}

	public Node getTargetNode() {
		return targetNode;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((sourceNode == null) ? 0 : sourceNode.hashCode());
		result = prime * result + ((targetNode == null) ? 0 : targetNode.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		NodeCorrespondence other = (NodeCorrespondence) obj;
		if (sourceNode == null) {
			if (other.sourceNode != null)
				return false;
		} else if (!sourceNode.equals(other.sourceNode))
			return false;
		if (targetNode == null) {
			if (other.targetNode != null)
				return false;
		} else if (!targetNode.equals(other.targetNode))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "NodeCorrespondence [sourceNode=" + sourceNode + ", targetNode=" + targetNode + "]";
	}

}
