package de.uni_potsdam.hpi.isg.efes.csg.mapping;

import de.uni_potsdam.hpi.isg.efes.csg.relationships.Relationship;

public class RelationshipCorrespondence {

	private Relationship sourceRelationship, targetRelationship;

	public RelationshipCorrespondence(Relationship sourceRelationship,
			Relationship targetRelationship) {
		super();
		this.sourceRelationship = sourceRelationship;
		this.targetRelationship = targetRelationship;
	}

	public Relationship getSourceRelationship() {
		return sourceRelationship;
	}

	public Relationship getTargetRelationship() {
		return targetRelationship;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((sourceRelationship == null) ? 0 : sourceRelationship.hashCode());
		result = prime * result
				+ ((targetRelationship == null) ? 0 : targetRelationship.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RelationshipCorrespondence other = (RelationshipCorrespondence) obj;
		if (sourceRelationship == null) {
			if (other.sourceRelationship != null)
				return false;
		} else if (!sourceRelationship.equals(other.sourceRelationship))
			return false;
		if (targetRelationship == null) {
			if (other.targetRelationship != null)
				return false;
		} else if (!targetRelationship.equals(other.targetRelationship))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "RelationshipCorrespondence [sourceRelationship=" + sourceRelationship
				+ ", targetRelationship=" + targetRelationship + "]";
	}

}
