package de.uni_potsdam.hpi.isg.efes.csg;

import java.util.Collection;
import java.util.Map;

import de.uni_potsdam.hpi.isg.efes.csg.constraints.ConstraintCollection;
import de.uni_potsdam.hpi.isg.efes.csg.constraints.ConstraintStorage;
import de.uni_potsdam.hpi.isg.efes.csg.nodes.Node;
import de.uni_potsdam.hpi.isg.efes.csg.relationships.Relationship;

public interface SchemaGraph extends ConstraintStorage {

	Map<String, Node> getAtomicNodes();

	/**
	 * Provides any non-empty atomic relationship in the graph that
	 * start at the given node.
	 * @param node is the node from which the atomic relationships start
	 * @return a collection of the outgoing relationships.
	 */
	Collection<Relationship> getAtomicRelationships(Node node);
	
	/**
	 * Provides any non-atomic relationship in the graph that
	 * start at the given node.
	 * @param node is the node from which the atomic relationships start
	 * @return a collection of the outgoing relationships.
	 */
	Collection<Relationship> getVirtualRelationships(Node node);

	ConstraintCollection getConstraints(Relationship relationship);

}
