package de.uni_potsdam.hpi.isg.efes.csg.constraints;

import de.uni_potsdam.hpi.isg.efes.csg.relationships.Relationship;

/**
 * Restricts an {@link Relationship} or a composition of those with a cardinality.
 * 
 * Cardinality means: relation maps to source elements to sets of target
 * elements; for each source element, take cardinality of target set; union over
 * all source elements
 * 
 * @author Sebastian Kruse
 */
public interface Constraint {
	
	Relationship getRelationship();
	
	NaturalNumberSet getCardinality();
	
	Constraint compose(Constraint otherConstraint);

}
