package de.uni_potsdam.hpi.isg.efes.csg.constraints;

import de.uni_potsdam.hpi.isg.efes.csg.relationships.Relationship;

public class ConstraintImpl implements Constraint {

	private NaturalNumberSet cardinality;
	private Relationship relationship;
	
	public ConstraintImpl(Relationship relationship,
			NaturalNumberSet cardinality) {
		this.cardinality = cardinality;
		this.relationship = relationship;
	}
	
	@Override
	public Constraint compose(Constraint otherConstraint) {
		Relationship newRelationship = this.relationship.compose(otherConstraint.getRelationship());
		NaturalNumberSet newCardinality = this.cardinality.compose(otherConstraint.getCardinality());
		return new ConstraintImpl(newRelationship, newCardinality);
	}
	
	public NaturalNumberSet getCardinality() {
		return cardinality;
	}
	
	public Relationship getRelationship() {
		return relationship;
	}

	@Override
	public String toString() {
		return "C(" + relationship + ")<=" + cardinality;
	}
	
}
