package de.uni_potsdam.hpi.isg.efes.csg.instance;

import java.util.Collection;

import de.uni_potsdam.hpi.isg.efes.csg.BasicSchemaGraph;
import de.uni_potsdam.hpi.isg.efes.csg.constraints.Constraint;
import de.uni_potsdam.hpi.isg.efes.csg.constraints.ConstraintStorage;
import de.uni_potsdam.hpi.isg.efes.csg.constraints.NaturalNumberBag;
import de.uni_potsdam.hpi.isg.efes.csg.constraints.NaturalNumberSet;
import de.uni_potsdam.hpi.isg.efes.csg.nodes.Node;
import de.uni_potsdam.hpi.isg.efes.csg.relationships.Relationship;

public interface SchemaGraphInstance extends ConstraintStorage {

	boolean hasDataStoreAdapter();

	DataStoreAdapter getDataStoreAdapter();
	
	NaturalNumberBag getRealCardinality(Relationship relationship);

	int getRealSize(Node node);

	NaturalNumberSet getPrescribedCardinality(Relationship relationship);

	BasicSchemaGraph getSchema();

	NaturalNumberSet getActualCardinality(Relationship relationship);

	Collection<Constraint> getViolatedConstraints();

	void setActualCardinality(Relationship relationship, NaturalNumberSet cardinality);

}
