package de.uni_potsdam.hpi.isg.efes.csg.nodes;

import java.util.Collection;


public interface Node extends Comparable<Node> {
	
	enum ContentType {
		EMPTY, MIXED, VALUE, IDENTITY;

		public ContentType mix(ContentType other) {
			return ContentType.mix(this, other);
		}
		
		public static ContentType mix(ContentType o1, ContentType o2) {
			switch (o1) {
			case EMPTY:
				return o2;
			case MIXED:
				return MIXED;
			default:
				break;
			}
			
			switch (o2) {
			case EMPTY:
				return o2;
			case MIXED:
				return MIXED;
			default:
				break;
			}
			
			if (o1 != o2) {
				return MIXED;
			}
			return o1;
			
		}
	}
	
	enum Operation {
		NONE, UNION, CROSS_PRODUCT;
	}

	boolean isSimpleIdentityNode();

	boolean isSimpleValueNode();
	
	/**
	 * @return the name of the schema element represented by this node
	 */
	String getName();
	
	ContentType getContentType();
	
	Operation getOperationType();
	
	boolean contains(Node node);
	
	boolean isMetaData();
	
	void setIsMetaData(boolean isMetaData);
	
	Collection<Node> getParentNodes();

	
}
