package de.uni_potsdam.hpi.isg.efes.csg.nodes;

public class ValueNode extends AbstractNode {

	private Datatype datatype;
	
	public ValueNode(String name, Datatype datatype) {
		super(name);
		this.datatype = datatype;
	}
	
	public Datatype getDatatype() {
		return datatype;
	}

	@Override
	public ContentType getContentType() {
		return Node.ContentType.VALUE;
	}

	@Override
	public Operation getOperationType() {
		return Node.Operation.NONE;
	}

	@Override
	public boolean contains(Node node) {
		return equals(node);
	}
	
	@Override
	public String toString() {
		return "(" + name + ")";
	}

}
