package de.uni_potsdam.hpi.isg.efes.csg.relationships;

public abstract class AbstractRelationship implements Relationship {

	private Relationship inverse;

	protected AbstractRelationship() {
	}

	protected AbstractRelationship(Relationship inverse) {
		this.inverse = inverse;
	}

	public Relationship compose(Relationship relationship) {
		if (!relationship.getStartNode().equals(getEndNode())) {
			throw new IllegalArgumentException();
		}
		return new CompositeRelationship(this, relationship);
	}

	@Override
	public Relationship getInverse() {
		if (this.inverse == null)
			this.inverse = createInverse();
		return this.inverse;
	}

	protected abstract Relationship createInverse();

	@Override
	public boolean isExplicit() {
		return getContentType() == Relationship.ContentType.EXPLICIT;
	}

	@Override
	public boolean isEmpty() {
		return getContentType() == Relationship.ContentType.EMPTY || getContentType() == Relationship.ContentType.EMPTY;
	}

}
