package de.uni_potsdam.hpi.isg.efes.csg.relationships;

import de.uni_potsdam.hpi.isg.efes.csg.constraints.ConstraintStorage;
import de.uni_potsdam.hpi.isg.efes.csg.constraints.NaturalNumberSet;
import de.uni_potsdam.hpi.isg.efes.csg.nodes.Node;

public class EqualityRelationship extends AbstractAtomicRelationship {

	public EqualityRelationship(Node startNode, Node endNode) {
		super(startNode, endNode);
	}

	protected EqualityRelationship(Node startNode, Node endNode,
			AbstractAtomicRelationship inverse) {
		super(startNode, endNode, inverse);
	}

	@Override
	protected AbstractAtomicRelationship createInverse() {
		return new EqualityRelationship(getEndNode(), getStartNode(), this);
	}

	@Override
	public NaturalNumberSet inferCardinality(ConstraintStorage constraintStorage) {
		return NaturalNumberSet.ZERO_OR_ONE;
	}
	
	@Override
	public ContentType getContentType() {
		return Relationship.ContentType.EQUALITY;
	}

	@Override
	public String toString() {
		return "[" + getStartNode() + "=" + getEndNode() + "]";
	}

}
