package de.uni_potsdam.hpi.isg.efes.csg.relationships;

import de.uni_potsdam.hpi.isg.efes.csg.constraints.ConstraintStorage;
import de.uni_potsdam.hpi.isg.efes.csg.constraints.NaturalNumberSet;
import de.uni_potsdam.hpi.isg.efes.csg.nodes.Node;

public class ExplicitAtomicRelationship extends AbstractAtomicRelationship {

	public ExplicitAtomicRelationship(Node startNode, Node endNode) {
		super(startNode, endNode);
	}

	protected ExplicitAtomicRelationship(Node startNode, Node endNode, AbstractAtomicRelationship inverse) {
		super(startNode, endNode, inverse);
	}

	@Override
	public NaturalNumberSet inferCardinality(ConstraintStorage constraintStorage) {
		return NaturalNumberSet.NATURAL_NUMBERS;
	}

	protected AbstractAtomicRelationship createInverse() {
		return new ExplicitAtomicRelationship(getEndNode(), getStartNode(), this);
	}

	@Override
	public ContentType getContentType() {
		return Relationship.ContentType.EXPLICIT;
	}

	@Override
	public String toString() {
		return "[" + getStartNode() + "->" + getEndNode() + "]";
	}

	
	
}
