package de.uni_potsdam.hpi.isg.efes.csg.relationships;

import java.util.Collection;
import java.util.Collections;

import de.uni_potsdam.hpi.isg.efes.csg.constraints.ConstraintStorage;
import de.uni_potsdam.hpi.isg.efes.csg.constraints.NaturalNumberSet;
import de.uni_potsdam.hpi.isg.efes.csg.nodes.Node;

public class IdentityRelationship extends AbstractAtomicRelationship {

	public IdentityRelationship(Node node) {
		super(node, node);
	}

	@Override
	public Relationship compose(Relationship relationship) {
		return relationship;
	}

	@Override
	public NaturalNumberSet inferCardinality(ConstraintStorage constraintStorage) {
		return NaturalNumberSet.ONE;
	}

	@Override
	protected AbstractAtomicRelationship createInverse() {
		return this;
	}

	@Override
	public Collection<Relationship> getAtomicRelationships() {
		return Collections.emptyList();
	}

	@Override
	public ContentType getContentType() {
		return Relationship.ContentType.EQUALITY;
	}
	
	@Override
	public OperationType getOperationType() {
		return Relationship.OperationType.IDENTITY;
	}

	@Override
	public String toString() {
		return "id" + getStartNode() + "";
	}

	
	
}
