package de.uni_potsdam.hpi.isg.efes.spicy.extensions;

import java.io.File;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "tableMappingConfiguration")
public class TableMappingConfiguration {

	private List<TableMapping> tableMappings;

	@XmlElement(name = "tableMapping")
	public List<TableMapping> getTableMappings() {
		return tableMappings;
	}

	public void setTableMappings(List<TableMapping> tableMappings) {
		this.tableMappings = tableMappings;
	}

	public static TableMappingConfiguration load(File file) {
		try {
			JAXBContext context = JAXBContext.newInstance(TableMappingConfiguration.class);
			Unmarshaller unmarshaller = context.createUnmarshaller();
			return (TableMappingConfiguration) unmarshaller.unmarshal(file);
		} catch (JAXBException e) {
			throw new RuntimeException(e);
		}
	}

	public static class TableMapping {

		private String source;
		private String target;

		@XmlElement
		public String getSource() {
			return source;
		}

		public void setSource(String source) {
			this.source = source;
		}

		@XmlElement
		public String getTarget() {
			return target;
		}

		public void setTarget(String target) {
			this.target = target;
		}

	}

}
