package de.uni_potsdam.hpi.isg.efes.spicy;

import java.io.IOException;
import java.io.InputStream;

import org.junit.Assert;
import org.junit.Test;
import org.xml.sax.SAXException;


public class SpicyParserTest {
	
	@Test
	public void testParseMusicbrainz2Discogs() throws SAXException, IOException {
		SpicyParser spicyParser = new SpicyParser();
		InputStream resourceAsStream = getClass().getResourceAsStream("/musicbrainz2discogs.xml");
		SpicyConfiguration spicyConfiguration = spicyParser.parse(resourceAsStream);
		
		SpicyConfiguration.RelationalDataset source = new SpicyConfiguration.RelationalDataset();
		source.setDbDriver("org.postgresql.Driver");
		source.setDbUri("jdbc:postgresql:musicbrainz_sample1");
		source.setDbLogin("postgres");
		source.setDbPassword("sergtsop");
		Assert.assertEquals(source, spicyConfiguration.getSource());
		
		SpicyConfiguration.RelationalDataset target = new SpicyConfiguration.RelationalDataset();
		target.setDbDriver("org.postgresql.Driver");
		target.setDbUri("jdbc:postgresql:discogs_sample1");
		target.setDbLogin("postgres");
		target.setDbPassword("sergtsop");
		Assert.assertEquals(target, spicyConfiguration.getTarget());
		
		SpicyConfiguration.Correspondence sampleCorrespondence = new SpicyConfiguration.Correspondence();
		sampleCorrespondence.setConfidence(1);
		sampleCorrespondence.setTransformationFunction("musicbrainz_sample1.artist_alias.artist_aliasTuple.name");
		sampleCorrespondence.addSourcePath("musicbrainz_sample1.artist_alias.artist_aliasTuple.name");
		sampleCorrespondence.setTargetPath("discogs_sample1.artists_aliases.artists_aliasesTuple.name");
		Assert.assertTrue(spicyConfiguration.getCorrespondences().contains(sampleCorrespondence));
		
		Assert.assertEquals(29, spicyConfiguration.getCorrespondences().size());
	}

}
