package de.uni_potsdam.hpi.isg.utils.db.metamodel;

public class NotNullConstraint implements Constraint {

	private Table table;
	private Column column;

	public NotNullConstraint(Table table, Column column) {
		this.table = table;
		this.column = column;
	}

	@Override
	public Type getType() {
		return Type.NOT_NULL;
	}

	@Override
	public boolean isApplicableTo(RelationalSchema schema) {
		return schema.getTables().containsValue(table) && table.getColumns().containsValue(column);
	}
	
	public Table getTable() {
		return table;
	}
	
	public Column getColumn() {
		return column;
	}

	@Override
	public String toString() {
		return "NotNullConstraint[table=" + table.getName() + ", column=" + column.getName() + "]";
	}
}
