package de.uni_potsdam.hpi.isg.utils.db.metamodel;

import java.util.HashMap;
import java.util.Map;

public class Table {

	private String name;

	private Map<String, Column> columns;
	
	public Table(String name) {
		if (name == null || name.isEmpty()) 
			throw new IllegalArgumentException();
		
		this.name = name;
		this.columns = new HashMap<String, Column>();
	}
	
	public Column addColumn(String columnName) {
		return addColumn(new Column(columnName));
	}
	
	public Column addColumn(Column column) {
		if (column == null || this.columns.containsKey(column.getName())) {
			throw new IllegalArgumentException();
		}
		this.columns.put(column.getName(), column);
		return column;
	}
	
	public String getName() {
		return name;
	}
	
	public Map<String, Column> getColumns() {
		return columns;
	}

	@Override
	public String toString() {
		return "Table[name=" + name + ", columns=" + columns + "]";
	}

}
