package de.uni_potsdam.hpi.isg.utils.sampling;

import it.unimi.dsi.fastutil.ints.IntIterator;
import it.unimi.dsi.fastutil.ints.IntOpenHashSet;
import it.unimi.dsi.fastutil.ints.IntSet;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class ListSampler {

	public static <T> List<T> sample(List<T> input, int size) {
		if (input.size() < size) {
			return new ArrayList<>(input);
		}
		Random random = new Random();
		IntSet pickedIndexes = new IntOpenHashSet(size);
		while (pickedIndexes.size() < size) {
			pickedIndexes.add(random.nextInt(input.size()));
		}
		
		List<T> result = new ArrayList<>(size);
		for (IntIterator i = pickedIndexes.iterator(); i.hasNext(); ) {
			result.add(input.get(i.nextInt()));
		}
		return result;
	}
	
}
