package de.uni_potsdam.hpi.isg.utils.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Map;

public class CollectionUtil {

	public static <T> T getAny(Collection<T> collection) {
		for (T t : collection) {
			return t;
		}
		throw new IllegalArgumentException("Collection does not have any elements.");
	}
	
	public static <Key, Value> boolean add(Key key, Value value, Map<Key, Collection<Value>> mapping) {
		Collection<Value> values = getValues(key, mapping);
		return values.add(value);
	}
	
	public static <Key, Value> boolean addChecked(Key key, Value value, Map<Key, Collection<Value>> mapping) {
		Collection<Value> values = getValues(key, mapping);
		if (!values.contains(value)) {
			return values.add(value);
		} else {
			return false;
		}
	}

	public static <Value, Key> Collection<Value> getValues(Key key, Map<Key, Collection<Value>> mapping) {
		Collection<Value> values = mapping.get(key);
		if (values == null) {
			values = new ArrayList<>();
			mapping.put(key, values);
		}
		return values;
	}
	
}
