package de.uni_potsdam.hpi.isg.utils.util;

public class MoreMath {

	public static int faculty(int n) {
		if (n < 0) {
			throw new IllegalArgumentException("Cannot compute faculty of " + n);
		}

		int faculty = 1;
		for (; n > 1; n--) {
			faculty *= n;
		}

		return faculty;
	}

	public static long binomialCoefficient(int n, int k) {
		if (n < k || k < 0)
			throw new IllegalArgumentException("Cannot comput binomial coefficient for " + n + " and " + k);

		int bigK = Math.max(k, n - k);
		int smallK = n - bigK;

		long result = 1;
		for (int i = n; i > bigK; i--) {
			result *= i;
		}
		result /= faculty(smallK);
		return result;
	}

	public static double logBinomialCoefficient(int n, int k) {
		int bigK = Math.max(k, n - k);
		int smallK = n - bigK;

		double result = 0;
		for (int i = n; i > bigK; i--) {
			result += Math.log(i);
		}
		for (int i = smallK; i > 1; i--) {
			result -= Math.log(i);
		}
		return result;
	}

	public static int sum(int... values) {
		int sum = 0;
		for (int value : values) {
			sum += value;
		}
		return sum;
	}
}
