package de.uni_potsdam.hpi.isg.utils.util;

public class Strings {

	public static <T> String join(Iterable<T> iterable, String separator) {
		StringBuilder sb = new StringBuilder();
		join(iterable, separator, sb);
		return sb.toString();
	}
	
	public static <T> void join(Iterable<T> iterable, String separator, StringBuilder sb) {
		String actualSeparator = "";
		for (T obj : iterable) {
			sb.append(actualSeparator).append(obj);
			actualSeparator = separator;
		}
	}
	
	public static String limit(String str, int limit) {
		if (str == null || str.length() <= limit) {
			return str;
		} else if (limit >= 4) {
			return str.substring(0, limit - 3) + "...";
		} else {
			return str.substring(0, limit);
		}
	}
	
}
