package de.uni_potsdam.hpi.isg.utils.settings;

import org.junit.Assert;
import org.junit.Test;

public class DatabaseSettingsTest {
	
	@Test
	public void testParsePostgresqlUri1() {
		String uri = "jdbc:postgresql:financials";
		String userName = "john.doe";
		String password = "test123456";
		DatabaseSettings settings = DatabaseSettings.from(uri, userName, password);
		
		Assert.assertEquals("postgresql", settings.dbType);
		Assert.assertEquals("financials", settings.dbName);
		Assert.assertEquals(userName, settings.dbUser);
		Assert.assertEquals(password, settings.dbPassword);
	}
	
	@Test
	public void testParsePostgresqlUri2() {
		String uri = "jdbc:postgresql://localhost/financials";
		String userName = "john.doe";
		String password = "test123456";
		DatabaseSettings settings = DatabaseSettings.from(uri, userName, password);
		
		Assert.assertEquals("postgresql", settings.dbType);
		Assert.assertEquals("financials", settings.dbName);
		Assert.assertEquals(userName, settings.dbUser);
		Assert.assertEquals(password, settings.dbPassword);
	}
	
	@Test
	public void testParsePostgresqlUri3() {
		String uri = "jdbc:postgresql://[::1]:5740/financials";
		String userName = "john.doe";
		String password = "test123456";
		DatabaseSettings settings = DatabaseSettings.from(uri, userName, password);
		
		Assert.assertEquals("postgresql", settings.dbType);
		Assert.assertEquals("financials", settings.dbName);
		Assert.assertEquals(userName, settings.dbUser);
		Assert.assertEquals(password, settings.dbPassword);
	}

}
