package de.uni_potsdam.hpi.isg.utils.util;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.junit.Assert;
import org.junit.Test;

public class PermutationsTest {

	@Test
	public void testPermutatingEmptyList() {
		List<Integer> list = Collections.emptyList();
		List<List<Integer>> permutations = Permutations.generateAllPermutations(list);
		Assert.assertEquals(1, permutations.size());
		Assert.assertTrue(permutations.contains(list));
	}
	
	@Test
	public void testPermutatingNonEmptyList() {
		List<Integer> list = Arrays.asList(1, 2, 3);
		List<List<Integer>> permutations = Permutations.generateAllPermutations(list);
		Assert.assertEquals(1 * 2 * 3, permutations.size());
		Assert.assertTrue(permutations.contains(list));
		Assert.assertTrue(permutations.contains(Arrays.asList(1, 3, 2)));
		Assert.assertTrue(permutations.contains(Arrays.asList(2, 1, 3)));
		Assert.assertTrue(permutations.contains(Arrays.asList(2, 3, 1)));
		Assert.assertTrue(permutations.contains(Arrays.asList(3, 1, 2)));
		Assert.assertTrue(permutations.contains(Arrays.asList(3, 2, 1)));
	}
}
